%define anolis_release 2

Summary:        A Modern Linker
Name:           mold
Version:        1.11.0
Release:        %{anolis_release}%{?dist}
License:        AGPL-3.0-or-later AND (Apache-2.0 OR MIT)
URL:            https://github.com/rui314/mold
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz

# Strip all Werror from the CFLAGS/CXXFLAGS when not building in strict mode
Patch0:         0000-tbb-strip-werror.patch
# Allow building against the system-provided `xxhash.h`
Patch1:         0001-Use-system-compatible-include-path-for-xxhash.h.patch
Patch2:         0001-mold-1.11.0-add-support-for-loongarch.patch

BuildRequires:  cmake, gcc, gcc-c++ >= 10
BuildRequires:  llvm, clang, gdb, glibc-static, libstdc++-static
BuildRequires:  libzstd-devel, mimalloc-devel, openssl-devel
BuildRequires:  xxhash-devel, zlib-devel, hwloc-devel
%ifarch x86_64
BuildRequires:  /usr/lib64/libc.so
%endif

Requires(post): %{_sbindir}/alternatives
Requires(preun): %{_sbindir}/alternatives

%global _description \
mold is a faster drop-in replacement for existing Unix linkers.\
It is several times faster than the LLVM lld linker.\
mold is designed to increase developer productivity by reducing\
build time, especially in rapid debug-edit-rebuild cycles.

%description %{_description}

%prep
%autosetup -p1
rm -r third-party/{mimalloc,xxhash,zlib,zstd}

%build
%cmake -DMOLD_USE_SYSTEM_MIMALLOC=ON
%cmake_build

%install
%cmake_install

%post
if [ "$1" = 1 ]; then
  %{_sbindir}/alternatives --install %{_bindir}/ld ld %{_bindir}/ld.mold 1
fi

%postun
if [ "$1" = 0 ]; then
  %{_sbindir}/alternatives --remove ld %{_bindir}/ld.mold
fi

%check
%ctest

%files
%license %{_docdir}/mold/LICENSE
%ghost %{_bindir}/ld
%{_bindir}/mold
%{_bindir}/ld.mold
%{_libdir}/mold/mold-wrapper.so
%{_libexecdir}/mold/ld
%{_mandir}/man1/ld.mold.1*
%{_mandir}/man1/mold.1*

%changelog
* Mon Apr 8 2024 Pengda Dou <doupengda@loongson.cn> - 1.11.0-2
- add support for loongarch

* Wed Apr 26 2023 DengXiewei <dengxiewei@linux.alibaba.com> - 1.11.0-1
- Initial package from upstream

